<?php
namespace CustomerPortal\Repositories;


class CallAttachment extends \Doctrine\ORM\EntityRepository {
    
    public function getCallAttachmentsDataSet($callId) {
        $query = "
            SELECT ATT.ID, ATT.LABEL,  ATT.FILENAME, ATT.FILETYPE AS FILE_TYPE, ATT.FILESIZE, ATT.CALL,
                   TO_CHAR(ATT.CREATED_AT, 'DD/MM/YYYY') AS CREATED_AT, OP.NMOPERADOR AS CREATED_BY
            FROM CALL_ATTACHMENT ATT
            INNER JOIN OPERADOR OP ON OP.CDOPERADOR = ATT.CREATED_BY
            WHERE ATT.CALL = :CALL_ID
        ";

        $params = array(
            'CALL_ID' => $callId
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getCallAttachmentsRelationships($callId) {
        $query = "
            SELECT LISTAGG(CALL_RELATIONSHIP_ATTACHMENT, ',') WITHIN GROUP(ORDER BY CA.CALL) as CALL_RELATIONSHIP_LIST
            FROM CALL_ATTACHMENT CA
            WHERE CA.CALL = :CALL_ID
            GROUP BY CA.CALL
        ";

        $params = array(
            'CALL_ID' => $callId
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
}