module.exports = function (grunt) {

	var srcPath = 'src/**/*.js';
	var packageName = 'zh-description';

	grunt.initConfig({
		concat: {
			zh: {
				options: {
					process: function(src, filepath) {
						return '// FILE: ' + filepath + '\n' + src + '\n';
					}
				},
				src: srcPath,
				dest: 'dist/' + packageName + '.js'
			}
		},
		jshint: {
			all: ['Gruntfile.js', srcPath]
		},
		uglify: {
			options: {
				mangle: false
			},
			target: {
				files: {
					'dist/zh-description.min.js': ['dist/' + packageName + '.js']
				}
			}
		},
		copy: {
			main: {
				expand: true,
				cwd: 'src/',
				src: 'templates/**/*',
				dest: 'dist/'
			}
		}
	});

	grunt.loadNpmTasks('grunt-contrib-concat');
	grunt.loadNpmTasks('grunt-contrib-jshint');
	grunt.loadNpmTasks('grunt-contrib-uglify');
	grunt.loadNpmTasks('grunt-contrib-copy');

	grunt.registerTask('default', ['jshint', 'concat', 'uglify', 'copy']);

};